;		TITLE  '(C) G3RFL DDS SIGNAL GENERATOR 16/5/2015'			
;		V1	using dsPIC30F4012 Micro 
;----------------------------------------
;	       		28 PIN DIL 
;			dsPIC30F4012
;                     ______  ______
;		    	     |      \/      |
;   PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;	            	 |              |
;         BUT1/RB0 --+ 2         27 +-- RB6  AVss
;	            	 |              |
;         BUT2/RB1 --+ 3         26 +-- RE0  SDA DISPLAY		
;	           	     |              |
;         BUT3/RB2 --+ 4         25 +-- RE1  SCL DISPLAY
;	                 |              |
;         BUT4/RB3 --+ 5         24 +-- RE2	             |
;	                 |              |
;         BUT5/RB4 --+ 6         23 +-- RE3
;	                 |              |
;              RB5 --+ 7         22 +-- RE4
;	                 |              |
;              VSS  -+ 8         21 +-- RE5
;	                 |              |
;              OSC --+ 9         20 +-- VDD
;	                 |              |
;             RC15 --+ 10        19 +-- VSS
;	                 |              |
;	          RC13 --+ 11        18 +-- RF2/PGC	
;	                 |              |
;	          RC14 --+ 12        17 +-- RF3/PGD
;	                 |              |
;              VDD --+ 13        16 +-- RE8/FQ_UD
;	                 |              |
;     SPI DATA/RD1 --+ 14        15 +-- RD0/W_CLK
;                    |______________|
;
;			PCF8574
;                     ______  ______
;		             |      \/      |
;               A0 --+ 1         16 +-- Vcc	
;	                 |              |
;               A1 --+ 2         15 +-- SDA
;	                 |              |
;               A2 --+ 3         14 +-- SCL		
;	                 |              |
;            RS/P0 --+ 4         13 +-- /INT
;	                 |              |
;    	     RW/P1 --+ 5         12 +-- P7/DB7
;	                 |              |
;   	      E/P2 --+ 6         11 +-- P6/DB6
;	                 |              |
;               P3 --+ 7         10 +-- P5/DB5
;	                 |              |
;              GND  -+ 8          9 +-- P4/DB4
;	                 |______________|
;	  
;
;		AD9850 DDS HC-SR08 SYNTH
;
;		GND	ZOUT2
;		D7	ZOUT1
;		D6	QOUT2
;		D5	QOUT1
;		D4	GND
;		D3	RESET
;		D2	DATA
;		D1	FU_UD
;		D0	W_CLK
;		VCC	VCC
;
;-----------------------------------------------------------------------------
       .equ __30F4012, 1
        .include "p30f4012.inc"
;..............................................................................
;Program Specific Constants (literals used in code)
;..............................................................................
;-------------- global declarations ---------------------------------------
	.global __reset
	.global __T2Interrupt
	.global __T1Interrupt
	.global __IC2Interrupt
	.global __U1RXInterrupt
;..............................................................................
;Constants stored in Program space
;..............................................................................
        .section .myconstbuffer, psv
;..............................................................................
;Code Section in Program Memory
;-----------------------------------------------------------------------------
;Configuration bits:
	config __FOSC, CSW_FSCM_OFF & FRC_PLL4
	config __FWDT,WDT_OFF
	config __PBORPOR, PBOR_OFF & MCLR_EN
	config __FGS, CODE_PROT_OFF

;-----------------------------------------------------------------------------        
;define constant
;PORTB
;PORTC
;PORTD
	.equ	sdata,#1
	
;PORTE
	.equ	sda,#0
	.equ	scl,#1

;-------------------------------------------
;define ram assignments
	.bss	intsreg,2	;temp stack register
	.bss	intwreg,2	;temp w register
	.bss	temp_pclath,2	;temp prog counter register
	.bss	Lin1,2
	.bss	Lin2,2
;	.bss	Lin3,2
	.bss	Lin4,2
	.bss	Lin5,2
	.bss	Lin6,2
	.bss	Lin7,2
	.bss	Lin8,2
	.bss	Lin9,2
	.bss	Lin10,2
	.bss	Lin11,2
	.bss	Lin12,2
	.bss	Lin13,2
	.bss	Lin14,2
	.bss	Lin15,2
	.bss	Lin16,2
	.bss	Lin17,2
	.bss	Lin18,2
	.bss	Lin19,2
	.bss	Lin20,2
	.bss	Lin21,2
	.bss	Lin22,2
	.bss	Lin23,2
	.bss	Lin24,2
	.bss	Lin25,2
	.bss	Lin26,2
	.bss	Lin27,2
	.bss	Lin28,2
	.bss	Lin29,2
	.bss	Lin30,2
	.bss	Lin31,2
	.bss	Lin32,2
	.bss	Lin33,2
	.bss	Lin34,2
	.bss	Lin35,2
	.bss	Lin36,2
	.bss	Lin37,2
	.bss	Lin38,2
	.bss	Lin39,2
	.bss	Lin40,2
	.bss	Lin41,2
	.bss	Lin42,2
	.bss	Lin3,2
	.bss	Lin44,2
	.bss	Lin45,2
	.bss	Lin46,2
	.bss	Lin47,2
	.bss	Lin48,2
	.bss	Lin49,2
	.bss	Lin50,2
	.bss	Lin51,2
	.bss	Lin52,2
	.bss	Lin53,2
	.bss	Lin54,2
	.bss	Lin55,2
	.bss	Lin56,2
	.bss	Lin57,2
	.bss	Lin58,2
	.bss	Lin59,2
;	.bss	Lin60,2
	.bss	Lin61,2
	.bss	Lin62,2
	.bss	Lin63,2
	.bss	Lin64,2
	.bss	Lin65,2
	.bss	Lin66,2
	.bss	Lin67,2
	.bss	Lin68,2
	.bss	Lin69,2
	.bss	Lin60,2
	.bss	Lin71,2
	.bss	Lin72,2
	.bss	Lin73,2
	.bss	Lin74,2
	.bss	Lin75,2
	.bss	Lin76,2
	.bss	Lin77,2
	.bss	Lin78,2
	.bss	Lin79,2
	.bss	Lin80,2
	.bss	control,2
	.bss	upper,2
	.bss	lower,2
	.bss	adval,2
	.bss	add_toggle,2
	.bss	count,2
	.bss	block,2
	.bss	synth1,2
	.bss	synth2,2
	.bss	synth3,2
	.bss	synth4,2
	.bss	bits,2
	.bss	datbuff,2
	.bss	pointer_numb,2
	.bss	temp1,2
	.bss	temp2,2
	.bss	digit1,2	
	.bss	digit2,2	
	.bss	digit3,2	
	.bss	digit4,2
	.bss	digit5,2
	.bss	digit6,2
	.bss	digit7,2
	.bss	digit8,2

;---------------------------------------------------
	.text				;start of code
__reset:
    mov 	#__SP_init, W15       	;Initalize the Stack Pointer
    mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
    mov 	W0, SPLIM
    nop                     	    ;Add NOP to follow SPLIM initialization
	mov		#0xffff,w0		
	mov		w0,ADPCFG	         	;all digital I/O	
	clr		LATB
	clr		LATC
	clr		LATD
	clr		LATE
	bset    CORCON, #PSV            ;Enable Program Space Visibility	                                                                                                                                                
;----------------------- INITIALISATION ----------------
init:
	call	init_ports
	call	init_lcd
	call	start_LCD
	clr		digit1
	clr		digit2
	clr		digit3
	clr		digit4
	clr		digit5
	clr		digit6
	clr		digit7
	clr		digit8
	bclr	LATD,#sdata
	clr		control
	rcall	calcdds
	call	tab1
	call	LCD_Line1
	call	send_buff1
	call	update_delay
	call	start_fq_ud	;reset address to W0
	call	w_clk		;input parrallel bits 0,1,2
	call	start_fq_ud	;now set to serial mode
	call	w_clk
	call	send_40
	clr		pointer_numb
	call	restore
;---------------------- MAIN ROUTINE ------------------
main:
	call	buttons
	call	disp_digits
	call	send_40
	rcall	calcdds
	call	update_delay
	goto	main
;---------------------- button freq control -------------
buttons:
	.equ	but1,0
	.equ	but2,1
	.equ	but3,2
	.equ	but4,3
	.equ	but5,4
	btst	PORTB,#but1
	bra		nz,next1
	mov		pointer_numb,w0
	add		#01,w0
	and		w0,#0x07,w0
	mov		w0,pointer_numb
	call	station
	call	start_LCD	
	call	header_LCD
	call	LCD_Line2
	call	send_buff2
next1:
	btst	PORTB,#but2
	bra		nz,next2

	mov		pointer_numb,w0 ;(0-7)
	bra		w0
	bra		d1	;0
	bra		d2	;1
	bra		d3	;2
	bra		d4
	bra		d5
	bra		d6
	bra		d7
	bra		d8
d1:
	mov		#0x09,w2
	mov		digit1,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit1
	call	save_ee1
	goto	next2
d2:
	mov		#0x09,w2
	mov		digit2,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit2
	call	save_ee2
	goto	next2
d3:
	mov		#0x09,w2
	mov		digit3,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit3
	call	save_ee3
	goto	next2
d4:
	mov		#0x09,w2
	mov		digit4,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit4
	call	save_ee4
	goto	next2
d5:
	mov		#0x09,w2
	mov		digit5,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit5
	call	save_ee5
	goto	next2
d6:
	mov		#0x09,w2
	mov		digit6,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit6
	call	save_ee6
	goto	next2
d7:
	mov		#0x09,w2
	mov		digit7,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit7
	call	save_ee7
	goto	next2
d8:
	mov		#0x09,w2
	mov		digit8,w1
	cp		w2,w1
	bra		eq,next2
	inc		digit8
	call	save_ee8
	goto	next2
next2:
	btst	PORTB,#but3
	bra		nz,next3
	mov		pointer_numb,w0 ;(0-7)
	bra		w0
	bra		d9	;0
	bra		d10	;1
	bra		d11	;2
	bra		d12
	bra		d13
	bra		d14
	bra		d15
	bra		d16
d9:
	mov		#0x00,w2
	mov		digit1,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit1
	call	save_ee1
	goto	next3
d10:
	mov		#0x00,w2
	mov		digit2,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit2
	call	save_ee2
	goto	next3
d11:
	mov		#0x00,w2
	mov		digit3,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit3
	call	save_ee3
	goto	next3
d12:
	mov		#0x00,w2
	mov		digit4,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit4
	call	save_ee4
	goto	next3
d13:
	mov		#0x00,w2
	mov		digit5,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit5
	call	save_ee5
	goto	next3
d14:
	mov		#0x00,w2
	mov		digit6,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit6
	call	save_ee6
	goto	next3
d15:
	mov		#0x00,w2
	mov		digit7,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit7
	call	save_ee7
	goto	next3
d16:
	mov		#0x00,w2
	mov		digit8,w1
	cp		w2,w1
	bra		eq,next3
	dec		digit8
	call	save_ee8
	goto	next3
next3:
	btst	PORTB,#but4
	bra	nz,next4
;	inc	digit4	
next4:
	btst	PORTB,#but5
	bra	nz,next5
;	inc	digit5	
next5:
	return
;------------------------ LCD Display ------------------------------
station:				  ;Sends Message Number W0 to LCD Display buffer
	bset    CORCON, #PSV              ;Enable Program Space Visibility
	mov		pointer_numb,w0
   	mov     #psvpage(index),W1    	;Set Program Space Visibility Page
   	mov     W1, PSVPAG                ;
    mov     #psvoffset(index),W1   ;Get Address of First Message into W1
	mov		#0x14,w2
	mul.uu	w0,w2,w2		;multiply by 20
    add.w   W2,W1,W1                 ;W1 = W1 + W0            ;W1 is now base address of ascii
send16:
    mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin21                  ;Send W0 byte to LCD  
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin22                 ;Send W0 byte to LCD 
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin23                  ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin24                 ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin25                  ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin26                 ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin27                  ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin28                 ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin29                 ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin30               ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin31                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin32                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin33                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin34                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin35                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin36                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin37                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin38                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin39                ;Send W0 byte to LCD
	mov.b	[W1++],W0                 ;Get Byte at W1 onto W0, then increment W1 by one
	mov		w0,Lin40                ;Send W0 byte to LCD
    return                            ;Return Job Done
;--- Calculate DDS Divisor ------------------------
	.equ	tensmhz,  343597383
	.equ	unitsmhz, 34359738
	.equ	hundskhz, 3435974
	.equ	tenskhz,  343597
	.equ	unitskhz, 34359
	.equ	hundshz,  3435
	.equ	tenshz,   343
	.equ	unitshz,  34
calcdds:
	clr		w0
	clr		w1
1:	mov		digit1,w4
	mov		#(tensmhz & 0xFFFF), w2
	mov		#((tensmhz>>16) & 0xFFFF), w3
2:	cp0		w4
	bra		z,3f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		2b
3:	mov		digit2,w4
	mov		#(unitsmhz & 0xFFFF), w2
	mov		#((unitsmhz>>16) & 0xFFFF), w3
4:	cp0		w4
	bra		z,5f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		4b
5:	mov		digit3,w4
	mov		#(hundskhz & 0xFFFF), w2
	mov		#((hundskhz>>16) & 0xFFFF), w3
6:	cp0		w4
	bra		z,7f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		6b
7:	mov		digit4,w4
	mov		#(tenskhz & 0xFFFF), w2
	mov		#((tenskhz>>16) & 0xFFFF), w3
8:	cp0		w4
	bra		z,9f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		8b
9:	mov		digit5,w4
	mov		#(unitskhz & 0xFFFF), w2
	mov		#((unitskhz>>16) & 0xFFFF), w3
10:	cp0		w4
	bra		z,11f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		10b
11:	mov		digit6,w4
	mov		#(hundshz & 0xFFFF), w2
	mov		#((hundshz>>16) & 0xFFFF), w3
12:	cp0		w4
	bra		z,13f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		12b
13:	mov		digit7,w4
	mov		#(tenshz & 0xFFFF), w2
	mov		#((tenshz>>16) & 0xFFFF), w3
14:	cp0		w4
	bra		z,15f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		14b
15:	mov		digit8,w4
	mov		#(unitshz & 0xFFFF), w2
	mov		#((unitshz>>16) & 0xFFFF), w3
16:	cp0		w4
	bra		z,17f
	dec		w4,w4
	add		w2,w0,w0
	addc	w3,w1,w1
	bra		16b
17:	mov		w1,synth3
	swap	w1
	mov		w1,synth4
	mov		w0,synth1
	swap	w0
	mov		w0,synth2
	return
;------------------ tables ------------------------
tab1:
	mov		#0x0035,w0	;5
	mov		w0,Lin1
	mov		#0x0030,w0	;0
	mov		w0,Lin2
	mov		#0x004d,w0	;M
	mov		w0,Lin3
	mov		#0x0048,w0	;H
	mov		w0,Lin4
	mov		#0x007a,w0	;z
	mov		w0,Lin5
	mov		#0x0020,w0	;" "
	mov		w0,Lin6
	mov		#0x0020,w0	;" "
	mov		w0,Lin7
	mov		#0x0053,w0	;S
	mov		w0,Lin8
	mov		#0x0049,w0	;I
	mov		w0,Lin9
	mov		#0x0047,w0	;G
	mov		w0,Lin10
	mov		#0x0020,w0	;" "
	mov		w0,Lin11
	mov		#0x0047,w0	;G
	mov		w0,Lin12
	mov		#0x0045,w0	;E
	mov		w0,Lin13
	mov		#0x004E,w0	;N
	mov		w0,Lin14
	mov		#0x0045,w0	;E
	mov		w0,Lin15
	mov		#0x0052,w0	;R
	mov		w0,Lin16
	mov		#0x0041,w0	;A
	mov		w0,Lin17
	mov		#0x0054,w0	;T
	mov		w0,Lin18
	mov		#0x004F,w0	;O
	mov		w0,Lin19
	mov		#0x0052,w0	;R
	mov		w0,Lin20
	return
;---------------------------------------------------
;	SUBROUTINES
;---------------------------------------------------
send_40:
	mov		synth1,w0
	mov		w0,datbuff
	call	send_8
	mov		synth2,w0
	mov		w0,datbuff
	call	send_8
	mov		synth3,w0
	mov		w0,datbuff
	call	send_8
	mov		synth4,w0
	mov		w0,datbuff
	call	send_8
	bclr	LATD,#sdata 	;control byte set to 00H
	call	w_clk
	call	w_clk
	call	w_clk
	call	w_clk
	call	w_clk
	call	w_clk
	call	w_clk
	call	w_clk
	call	start_fq_ud		;now set to serial mode
	call	w_clk
	return
;---------------------------------------------
send_8:
	mov		#0x08,w0
	mov		w0,bits
loop8:
	bclr	LATD,#sdata
	btst	datbuff,#0
	bra		z,zero
	bset	LATD,#sdata
zero:
	call	w_clk
	lsr		datbuff
	dec		bits
	bra		nz,loop8	
	return
;---------------------------------------------
disp_digits:
	mov		#0x0020,w0	;" "
	mov		w0,Lin21
	mov		digit1,w0
	add		#0x30,w0
	mov		w0,Lin22
	mov		digit2,w0
	add		#0x30,w0
	mov		w0,Lin23
	mov		#0x4d,w0	;M
	mov		w0,Lin24	
	mov		#0x48,w0	;H
	mov		w0,Lin25
	mov		#0x7a,w0	;z
	mov		w0,Lin26
	mov		#0x0020,w0	;" "
	mov		w0,Lin27
	mov		digit3,w0
	add		#0x30,w0
	mov		w0,Lin28
	mov		digit4,w0
	add		#0x30,w0
	mov		w0,Lin29
	mov		digit5,w0
	add		#0x30,w0
	mov		w0,Lin30
	mov		#0x4b,w0	;K
	mov		w0,Lin31
	mov		#0x48,w0	;H
	mov		w0,Lin32
	mov		#0x7a,w0	;z
	mov		w0,Lin33
	mov		#0x0020,w0	;" "
	mov		w0,Lin34
	mov		digit6,w0
	add		#0x30,w0
	mov		w0,Lin35
	mov		digit7,w0
	add		#0x30,w0
	mov		w0,Lin36
	mov		digit8,w0
	add		#0x30,w0
	mov		w0,Lin37
	mov		#0x48,w0	;H
	mov		w0,Lin38
	mov		#0x7a,w0	;z
	mov		w0,Lin39
	mov		#0x0020,w0	;" "
	mov		w0,Lin40
	call	LCD_Line3	
	call	send_buff2
	return
;-------------------------------------------------
start_fq_ud:
	bset	LATE,#8
	repeat	#100
	nop
	bclr	LATE,#8
	repeat	#100
	nop
	return
;--------------------------------------------------
w_clk:
	bset	LATD,#0
	repeat	#100
	nop
	bclr	LATD,#0
	repeat	#100
	nop
	return
;------------------ INIT LCD START ADDRESS -------------------
LCD_Line1:
	mov		#0x80,w0	;send to control register
	call	bld_command
	return
LCD_Line2:
	mov		#0x94,w0	;send to control register
	call	bld_command
	return
LCD_Line3:
	mov		#0xa8,w0	;send to control register
	call	bld_command
	return
LCD_Line4:
	mov		#0xbc,w0	;send to control register
	call	bld_command
	return
;------------------ INIT LCD SETTUP -------------------
init_lcd_tab:
	bra		w0	
	retlw	#0x38,w0	;0
	retlw	#0x38,w0	;1		;30
	retlw	#0x04,w0	;command
	retlw	#0x08,w0	;turn lcd on	;08
	retlw	#0x0c,w0	;4		;02
	retlw	#0x00,w0	;5
	retlw	#0x24,w0	;6	
	retlw	#0x00,w0	;sets up two line operation
;------------------------------------------------------
i2c_clk_LCD:
	bset	LATE,#scl
	call	I2C_dly
	nop
	nop
	bclr	LATE,#scl
	return
;------------------------- small delay ------------------
I2C_dly:
	repeat	#1000
	nop
	return
;----------------------------------------------------
init_lcd:
;		01	REGISTER SELECT
;		02	READ/WRITE SELECT
;		04	ENABLE BIT
	call	start_LCD
	call	header_LCD	;send i2c address "4e"
	mov		#0x0000,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;set DL to be 4 bit
	call	sendlcd
	mov		#0x0001,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;1
	call	sendlcd
	mov		#0x0002,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;2
	call	sendlcd
	mov		#0x0003,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;3
	call	sendlcd
	mov		#0x0004,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;4
	call	sendlcd
	mov		#0x0005,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;5
	call	sendlcd
	mov		#0x0006,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;6
	call	sendlcd
	mov		#0x0007,w0
	call	init_lcd_tab 
	mov		w0,datbuff	;7
	call	sendlcd
	return
;------------------------------
bld_byte:
	push	w0
	mov		w0,upper
	sl		w0,#4,w0
	mov		w0,lower
	bset	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bset	upper,#0
	goto	ext
;------------------------------
bld_command:
	push	w0
	mov		w0,upper
	sl		w0,#4,w0
	mov		w0,lower
	bclr	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bclr	upper,#0
ext:
	bclr	upper,#1
	bset	upper,#2
	bset	upper,#3
	mov		upper,w0
	mov		w0,datbuff
	call	sendlcd
	bclr	upper,#2
	mov		upper,w0
	mov		w0,datbuff
	call	sendlcd
	mov		lower,w0
	mov		w0,datbuff
	call	sendlcd
	bclr	lower,#2
	mov		lower,w0
	mov		w0,datbuff
	call	sendlcd	
	pop		w0
	return
;------------------------------
header_LCD:
	mov		#0x4e,w0	;lcd address
	mov		w0,datbuff
	call	sendlcd		;send address to i2c chip
	return
;---------------------------------
sendlcd:
	mov		datbuff,w0	;saved data
	mov		w0,temp2	;this will get destroyed
	mov		#0x08,w0	;send 8 bits
	mov		w0,temp1
send8_i2c:
	bclr	LATE,#sda
	btsc	temp2,#0x07
	bset	LATE,#sda	;set data bit	
	sl		temp2	
	call	i2c_clk
	dec		temp1
	bra		nz,send8_i2c
	bset	LATE,#sda
	call	i2c_clk		;ack bit clock
	return
;----------------------
start_LCD:
	bclr	LATE,#sda
	nop
	nop
	nop
	bclr	LATE,#scl	;start condition
	return
;----------------------
stop_LCD:
	bset	LATE,#scl
	nop
	nop
	nop
	bset	LATE,#sda	;stop condition
	return
;---------------------------------------------------------
i2c_clk:
	bset	LATE,#scl
	nop
	nop
	nop
	nop
	nop
	nop
	bclr	LATE,#scl	;synth clock pulse
	return
;------------------------ load buffers to display ram --------
send_buff1:
	call	start_LCD
	mov		Lin1,w0
	call	bld_byte
	mov		Lin2,w0
	call	bld_byte
	mov		Lin3,w0
	call	bld_byte
	mov		Lin4,w0
	call	bld_byte
	mov		Lin5,w0
	call	bld_byte
	mov		Lin6,w0
	call	bld_byte
	mov		Lin7,w0
	call	bld_byte
	mov		Lin8,w0
	call	bld_byte
	mov		Lin9,w0
	call	bld_byte
	mov		Lin10,w0
	call	bld_byte
	mov		Lin11,w0
	call	bld_byte
	mov		Lin12,w0
	call	bld_byte
	mov		Lin13,w0
	call	bld_byte
	mov		Lin14,w0
	call	bld_byte
	mov		Lin15,w0
	call	bld_byte
	mov		Lin16,w0
	call	bld_byte
	mov		Lin17,w0
	call	bld_byte
	mov		Lin18,w0
	call	bld_byte
	mov		Lin19,w0
	call	bld_byte
	mov		Lin20,w0
	call	bld_byte
	call	stop_LCD
	return
send_buff2:
	call	start_LCD
	mov		Lin21,w0
	call	bld_byte
	mov		Lin22,w0
	call	bld_byte
	mov		Lin23,w0
	call	bld_byte
	mov		Lin24,w0
	call	bld_byte
	mov		Lin25,w0
	call	bld_byte
	mov		Lin26,w0
	call	bld_byte
	mov		Lin27,w0
	call	bld_byte
	mov		Lin28,w0
	call	bld_byte
	mov		Lin29,w0
	call	bld_byte
	mov		Lin30,w0
	call	bld_byte
	mov		Lin31,w0
	call	bld_byte
	mov		Lin32,w0
	call	bld_byte
	mov		Lin33,w0
	call	bld_byte
	mov		Lin34,w0
	call	bld_byte
	mov		Lin35,w0
	call	bld_byte
	mov		Lin36,w0
	call	bld_byte
	mov		Lin37,w0
	call	bld_byte
	mov		Lin38,w0
	call	bld_byte
	mov		Lin39,w0
	call	bld_byte
	mov		Lin40,w0
	call	bld_byte
	call	stop_LCD
	return
;--------------------------- SET UP PORTS -----------------
init_ports:
	clr		PTCON
	clr		PWMCON1
	clr		OVDCON
	clr		LATB
	mov		#0x0000,w0	;0=output
	mov		w0,TRISC
	mov		#0x003f,w0
	mov		w0,TRISB	;1=input
	mov		#0x0000,w0
	mov		w0,TRISD
	mov		#0x3c,w0
	mov		w0,TRISE
	call	stop_LCD
	bset	CNPU1,#2	;input pull-ups RBX
	bset	CNPU1,#3
	bset	CNPU1,#4	;input pull-ups RBX
	bset	CNPU1,#5
	bset	CNPU1,#6	;input pull-ups RBX
	return
;---------------- display update delay ----------
update_delay:
	mov	#0x0080,w3	
big:
	repeat	#16000
	nop
	dec		w3,w3
	bra		nz,big
	return
;--------------------------------------------
delay:
	repeat	#16000
	nop
	repeat	#16000
	nop
	repeat	#16000
	nop
	return
;-------------- RESTORE FREQ and D/A --------
restore:
	call	index1
	TBLRDL	[w0++],w4
	mov		w4,digit1
	TBLRDL	[w0++],w4
	mov		w4,digit2
	TBLRDL	[w0++],w4
	mov		w4,digit3
	TBLRDL	[w0++],w4
	mov		w4,digit4
	TBLRDL	[w0++],w4
	mov		w4,digit5
	TBLRDL	[w0++],w4
	mov		w4,digit6
	TBLRDL	[w0++],w4
	mov		w4,digit7
	TBLRDL	[w0++],w4
	mov		w4,digit8
	return
;------------ SAVE FREQ DATA TO EEPROM -----------
erase:
	mov		w0,NVMADR
	mov		w1,NVMADRU
	mov		#0x4044,w0
	mov		w0,NVMCON
	call	key
	return
;---------------------- 
save_ee1:
	call	index1
	call	erase
	call	index1
	mov		digit1,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee2:
	call	index2
	call	erase
	call	key
	call	index2
	mov		digit2,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee3:
	call	index3
	call	erase
	call	index3
	mov		digit3,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee4:
	call	index4
	call	erase
	call	index4
	mov		digit4,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee5:
	call	index5
	call	erase
	call	index5
	mov		digit5,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee6:
	call	index6
	call	erase
	call	index6
	mov		digit6,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee7:
	call	index7
	call	erase
	call	index7
	mov		digit7,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
save_ee8:
	call	index8
	call	erase
	call	index8
	mov		digit8,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return

;------------------ SAVE ONE WORD IN EERPOM -------------
key:
	DISI	#5
	mov		#0x55,w0
	mov		w0,NVMKEY
	mov		#0xaa,w1
	mov		w1,NVMKEY
	bset	NVMCON,#WR
notdone:
	btsc	NVMCON,#WR	
	bra		notdone
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC00)-------------------------
index1:
	mov		#0xfc00,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC02)-------------------------
index2:
	mov		#0xfc02,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC04)-------------------------
index3:
	mov		#0xfc04,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC06)-------------------------
index4:
	mov		#0xfc06,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC08)-------------------------
index5:
	mov		#0xfc08,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC0a)-------------------------
index6:
	mov		#0xfc0a,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC0c)-------------------------
index7:
	mov		#0xfc0c,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC0e)-------------------------
index8:
	mov		#0xfc0e,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;----------------------- Radio ATV station data tables ----------
index:
.ascii	" ^                  "
.ascii  "  ^                 "
.ascii	"       ^            "
.ascii  "        ^           "
.ascii	"         ^          "
.ascii  "              ^     "
.ascii	"               ^    "
.ascii  "                ^   "
;---------------------------------------------------
	.section eeprom, eedata

mydata:
	.word	0x0001	;0x7ffc0
	.word	0x0002
	.word	0x0003
	.word	0x0004
	.word	0x0005
	.word	0x0006
	.word	0x0007
	.word	0x0008
;--------------------------------------------
	.end




